#ifndef id4617732A05EA419CA0CD21B7338E5471
#define id4617732A05EA419CA0CD21B7338E5471

#include "doorkeeper/primitivetypes.hpp"
#include "doorkeeper/components/pixelconv.hpp"
#include <vector>

namespace dk {
	template <uint32_t D>
	class PixelConv;

	template <typename T, uint32_t D>
	class Tile {
	public:
		typedef Vector<D> coords;

		Tile ( T* parData, const TileCoords<D>& parPos, const coords& parBlockOffs, const PixelConv<D>* parPConv );

		const T& data ( void ) const;
		T& data ( void );
		const coords& block_position ( void ) const;
		const TileCoords<D>& raw_coords ( void ) const;
		coords screen_position ( void ) const;

	private:
		const TileCoords<D> m_position;
		const coords m_block_offs;
		const PixelConv<D>* const m_pixconv;
		T* const m_data;
	};
} //namespace dk

#include "doorkeeper/implem/tile.inl"

#endif
